
#ifndef _PCX_H_
#define _PCX_H_

#define PCXFILLER        (128-74)		// 54

#if 0 // unused PCX file header, but not deleted for further improvements ;-))
typedef struct
{
  char  Manufacturer;		// keyword (10 decimal)
  char  Version;		// hardware version (5, old files with no palette are 3)
  char  Encoding;		// run length encoded (1)
  char  BitsPerPixelPlane;	// bits per pixel per plane
  short  Xmin;			// picture dimensions in pixels
  short  Ymin;
  short  Xmax;
  short  Ymax;
  short  Hdpi;			// horizontal image dpi
  short  Vdpi;			// vertical image dpi
  char  Pal[48];		// palette
  char  VMode;			// monitor (ignored)
  char  NumPlanes;		// number of planes in image 
  short  BytesPerLine;		// bytes per line per plane in picture 
  short  PalInfo;		// grayscale/color flag (obsolete)
  short  HScreenSize;		// horizontal screen size in pixels
  short  VScreenSize;		// vertical screen size in pixels

  // The rest of the 128 byte header is not used
  char Filler[PCXFILLER];	// (reserved, should be zero)
  char Data;		        // start of image data (unbounded)
} PCXHEAD;
#endif


typedef struct
{
  char *FileName;
  char *ImageData;
  unsigned long Width;
  unsigned long Height;
  char *Palette;
  unsigned long PaletteSize;	
} PCXENCODE;

// prototype
int EncodePCX( PCXENCODE *Encode);

#endif		// #ifndef _PCX_H_

